<?php
// +----------------------------------------------------------------------
// | VitPHP
// +----------------------------------------------------------------------
// | 版权所有 2018~2021 藁城区创新网络电子商务中心 [ http://www.vitphp.cn ]
// +----------------------------------------------------------------------
// | VitPHP是一款免费开源软件,您可以访问http://www.vitphp.cn/以获得更多细节。
// +----------------------------------------------------------------------


namespace app\cx_gqimg\controller;

use think\facade\Db;
use think\facade\Request;
use think\facade\View;

class Index extends Base
{
    public function index()
    {
        $pid = input('pid');

        $wechatInfo = session('user_wechat');

        $thisUrl = $this->request->domain() . $this->request->url();
        $weixinConfig = Db::name('cx_gqimg_weixin')->where(['pid' => $pid])->find();
        $config = [
            'appsecret' => $weixinConfig['appsecret'],
            'appid' => $weixinConfig['appid'],
        ];
        $scriptWechat = new \WeChat\Script($config);
        $wechatShareConfig = $scriptWechat->getJsSign($thisUrl);
        $jsApiList = '';
        foreach ($wechatShareConfig['jsApiList'] as $jsApi) {
            $jsApiList .= '"' . $jsApi . '",';
        }

        if (!$wechatInfo || !$wechatInfo['openid']) {
            $wechat = new \WeChat\Oauth($config);
            if (!input('code')) {
                $redirectUrl = $wechat->getOauthRedirect($thisUrl, '123', 'snsapi_userinfo');
                return redirect($redirectUrl);
            } else {
                $result = $wechat->getOauthAccessToken();
                $wechatInfo = $wechat->getUserInfo($result['access_token'], $result['openid']);
                session('user_wechat', $wechatInfo);
            }
        }

        $guest = Db::name('cx_gqimg_user')->where(['pid' => $pid, 'openid' => $wechatInfo['openid']])->find();
        if (!$guest) {
            Db::name('cx_gqimg_user')->insert([
                'pid' => $pid,
                'openid' => $wechatInfo['openid'],
                'headimgurl' => $wechatInfo['headimgurl'],
                'nickname' => $wechatInfo['nickname'],
                'create_time' => time(),
            ]);
        }

        $imageInfo = getimagesize($wechatInfo['headimgurl']);
        $img = 'data:' . $imageInfo['mime'] . ';base64,' . chunk_split(base64_encode(file_get_contents($wechatInfo['headimgurl'])));
        $img = str_replace(array("\r\n", "\r", "\n"), "", $img);


        $shareLink = $this->request->domain() . url('index/index', ['pid' => $pid])->build();
        $wechatShare = [
            'title' => $weixinConfig['fx_title'] ?? '',
            'desc' => $weixinConfig['fx_miaoshu'] ?? '',
            'link' => $shareLink,
            'imgUrl' => $this->getFullMediaUrl($weixinConfig['fx_img'])
        ];

        $guajianWebPath = 'app' . DIRECTORY_SEPARATOR . 'cx_gqimg' . DIRECTORY_SEPARATOR . 'guajian' . DIRECTORY_SEPARATOR;
        $guajianPath = app()->getRootPath() . 'public' . DIRECTORY_SEPARATOR . $guajianWebPath;
        $guajianFiles = scandir($guajianPath);
        $guajians = [];
        foreach ($guajianFiles as $gFile) {
            if ($gFile == '.' || $gFile == '..') continue;
            $guajians[] = DIRECTORY_SEPARATOR . $guajianWebPath . $gFile;
        }

        View::assign([
            'wechatShareConfig' => $wechatShareConfig,
            'jsApiList' => $jsApiList,
            'wechatShare' => $wechatShare,
            'title' => $weixinConfig['fx_title'],
            'guajians' => $guajians,
            'banquan' => $weixinConfig['gg_text'],
            'gg_url' => $weixinConfig['gg_url'],
            'qrcode' => $weixinConfig['qrcode'],
            'headimgurl' => $img
        ]);
        return View::fetch();
    }
}